

package Reflecter;

import java.lang.reflect.*;
import java.util.concurrent.*;

public class ReflecterReflection implements Reflecter_Interface
{
	//javasitptNV̑ւ.

	public Object invoke(String className,	String methodName,	Object[] args)
	{
		//NX/\bhw肵ꍇ,ɃCX^X𐶐Ăs.

		Object ret = null;

		if ( args == null)
		{
			//Ȃꍇnullnꍇ
			args = new Object[0];
		}

		try {
			Class cls = Class.forName( className );

			Object inst = cls.newInstance();

			ret = invoke( inst, methodName, args);

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

		return ret;

	}

	public Object invoke(Object instance,	String methodName,	Object[] args)
	{
		//NX̓CX^Xς݂̂,\bhĂяo.

		Object ret = null;

		if ( args == null)
		{
			//Ȃꍇnullnꍇ
			args = new Object[0];
		}

		try {
			Class cls = instance.getClass();

			Object inst = instance;


			/*
			Class[] params = new Class[ args.length ];
			for( int i=0; i < params.length; i++)
			{
				//^Cv쐬
				params[i] = args[i].getClass();
			}

			Method method = cls.getMethod( methodName, params);
			*/

			Method	method = ReflecterTools.getMethod( cls.getName(), methodName, args);

			ret = invoke( inst, method, args);

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

		return ret;

	}



	public Object invoke(Object instance, Method method, Object[] args)
	{

		//ɑ݂CX^X𗘗pthis|C^ēn.
		//static\bh̏ꍇł,Ȃ.

		Object ret = null;
		
		try {

			ret = method.invoke( instance, (Object[])args);

		} catch (Exception e ) {

			e.printStackTrace();
		}

		return ret;

	}



	public Object[] invokeParallels(String className, String methodName, Object[][] argses)
	{
		//NX/\bhw肵ꍇ,ɃCX^X𐶐Ăs.

		Object[] rets = null;

		try {
			Class cls = Class.forName( className );

			Object inst = cls.newInstance();

			rets = invokeParallels( inst, methodName, argses);

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}




		return rets;
	}

	public Object[] invokeParallels(Object instance, String methodName, Object[][] argses)
	{


		Object[] rets = null;


		if ( argses[0] == null)
		{
			argses[0] = new Object[0];
		}

		try {
			Class cls = instance.getClass();

			Object inst = instance;

			Method	method = ReflecterTools.getMethod( cls.getName(), methodName, argses[0]);

			rets = invokeParallels( inst, method, argses);

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

		

		return rets;
	}




	
	public Object[] invokeParallels(Object instance, Method method, Object[][] argses)
	{
		// 񏈗p.

		if ( argses.length < 2)
		{
			return invokeParallelsNonThread( instance, method, argses);
		}


		Parallels[] ps = new Parallels[ argses.length ];
		for( int i=0; i < argses.length; i++)
		{
			ps[i] = new Parallels();
			ps[i].reflecterThreadStarter(instance, method, argses[i], this);
		}

		Object[] rets = new Object[argses.length];
		for( int i=0; i < rets.length; i++)
		{
			rets[i] = ps[i].getReturnValue();


		}

		
		return rets;
	}
	


	
	
	public Object[] invokeParallelsNonThread(Object instance, Method method, Object[][] argses)
	{
		//eXgp@Xbh

		Object[] rets = new Object[ argses.length ];
		
		for( int i =0; i < argses.length; i++)
		{
			rets[i] = invoke( instance, method, argses[i] );
		}

		return rets;
	}
	


	private class Parallels extends Thread
	{
		

		private Semaphore exit_flag = new Semaphore(1);
		private Object return_value = null;

		private Object instance;
		private Method method;
		private Object[] args;

		private boolean exit_operation = true;

		private Reflecter_Interface reflecter;

		public void run()
		{

			exit_operation = false;

			try {

				this.return_value = reflecter.invoke( this.instance, this.method, this.args);

				exit_flag.release();
			} catch (Exception e) {
				e.printStackTrace();
			}

			exit_operation = true;

		}

		public void reflecterThreadStarter( Object instance, Method method, Object[] args, Reflecter_Interface reflecter)
		{

			
			try {
				exit_flag.acquire();

				this.exit_operation = false;


				this.instance = instance;
				this.method = method;
				this.args = args;

				this.reflecter = reflecter;

				this.start();
			} catch (Exception e) {
				System.out.println("reflecterThreadStarter() failed\n");
				e.printStackTrace();
			}

			return ;
		}

		public Object getReturnValue()
		{

			//System.out.println("ReflecterReflection.getReturnValue() called\n");
		
			try {
				exit_flag.acquire();


				//while(exit_operation != true)
				{
					//Z}tHȂǂpɓ邽.sv?

				}

				Object ret = return_value;
				exit_flag.release();

				return ret;
			} catch (Exception e) {

				System.out.println("ReflecterReflection.getReturnValue() failed\n");

				e.printStackTrace();
				return null;
			}
		}
	
	}




}
		

	
		
