
package jnios;

import java.io.*;
import org.python.core.*;


public class PosixFile {
    private long f_fp = 0;
    private String f_name;
    private String f_mode;
    int softspace;
    private long f_close;
 
    public PosixFile(long fp, String name, String mode, long close) {
	f_fp = fp;
	f_mode = mode;
	f_name = name;
	softspace = 0;
	f_close = close;
    }


    public native void setbufsize(int bufsize);


    public String read() {
	return read(-1);
    }

    public native String read(long l);


    //public native String readinto(...);


    public String readline() {
	return readline(-1);
    }

    public native String readline(int l);


    public PyList readlines() {
	return readlines(0);
    }

    public native PyList readlines(int sizehint);


    public native void write(String s);


    public native void writelines(String[] list);


    public native Object tell();


    public native int fileno();

    public native int isatty();


    public void seek(long pos) {
	seek(pos, 0);
    }

    public native void seek(long pos, int whence);


    public native void flush();


    public void truncate() {
	truncate(-1);
    }

    public native void truncate(long newsize);


    public native int close();


    public void finalize() {
	close();
    }


    public String toString() {
	return "<" + (f_fp == 0 ? "closed" : "open") + " file '" + f_name + 
		"', mode '" + f_mode + "' at " + hashCode() + ">";
    }
}

